
/*-----------------------------------------------------------------------------------------------------------------------------------
| -----------------------------------------------------------------------------------------------------------------------------------
|
|	DrawPileDelegate : Object
|
|	Instances of this class provide a visual representation of a pile of cards.  CardPileView
|	uses CardPile as the underlying representation, but adds a visual aspect and user
|	interaction.  Users can click on CardPileViews and drag cards from one view to another.
|	The decisions on when this is allowed and what happens as a result are left to the
|	CardPileView's delegate.
|
| -----------------------------------------------------------------------------------------------------------------------------------
\----------------------------------------------------------------------------------------------------------------------------------*/

#import <appkit/appkit.h>

@interface DrawPileDelegate:Object
{
	id		discardCardPileView ;
	id		recycleCardPile ;
}

/*----------------------------------------------------------------------------
|
|	CardPileView delegation methods
|
\---------------------------------------------------------------------------*/

- clickedCard: aCard in: drawCardPileView ;

@end