
#import "GamePileDelegate.h"
#import "CardSet.subproj/cardset.h"

@implementation GamePileDelegate

- clickedCard: aCard in: aCardPileView
{
	id		cardPile = [ aCardPileView cardPile ] ;

	if ( ( aCard == [ cardPile cardAt: CS_TOP ] ) && ( ! [ aCard isFaceUp ] ) )
	{
		[ aCard flip ] ;
		[ aCardPileView display ] ;
	}
	return self ;
}


- (BOOL) draggedPile: aCardPile from: aCardPileView
{
	id		cardPile = [ aCardPileView cardPile ] ;
	id		firstCard = [ aCardPile cardAt: CS_TOP ] ;
	int		cardIndex = [ cardPile cardIndex: firstCard ] ;

	if ( [ firstCard isFaceUp ] )
	{
		while ( ++cardIndex < [ cardPile cardCount ] )
		{
			[ aCardPile addCard: [ cardPile cardAt: cardIndex ] ] ;
		}
		return YES ;
	}
	return NO ;
}


- (BOOL) canAcceptPile: aCardPile in: aCardPileView
{
	id		droppingCard = [ aCardPile cardAt: CS_BOTTOM ] ;
	id		targetCard = [ [ aCardPileView cardPile ] cardAt: CS_TOP ] ;
	
	if ( targetCard )
	{
		if ( ( [ targetCard isFaceUp ] ) &&
				( [ targetCard cardColor ] != [ droppingCard cardColor ] ) &&
				( [ targetCard value ] == [ droppingCard value ] + 1 ) )
		{
			return YES ;
		}
	}
	else
	{
		if ( [ droppingCard value ] == CS_KING )
		{
			return YES ;
		}
	}
	return NO ;
}


- getOffset: (float *) xOffset : (float *) yOffset
{
	*xOffset = 0.0 ;
	*yOffset = 20.0 ;
	return self ;
}

@end
