
#import "CardSet.subproj/cardset.h"

#import "Solitaire.h"

@implementation Solitaire

- appDidInit: sender
{
	[ self newGame: self ] ;
	return self ;
}


- newGame: sender
{
	int		pileIndex, cardIndex ;
	id		suitCardPiles [ 4 ] = { suitCardPileView1, suitCardPileView2,
					suitCardPileView3, suitCardPileView4 } ;
	id		gameCardPiles [ 7 ] = { gameCardPileView1, gameCardPileView2,
					gameCardPileView3, gameCardPileView4,
					gameCardPileView5, gameCardPileView6,
					gameCardPileView7 } ;
	id		gameWindow = [ drawCardPileView window ] ;
	id		drawCardPile = [ drawCardPileView cardPile ] ;

	[ gameWindow disableFlushWindow ] ;

	//---------------------------------------------------------------------------
	//	Empty the recycle pile
	//---------------------------------------------------------------------------
	
	[ recycleCardPile freeCards ] ;

	//---------------------------------------------------------------------------
	//	Initialize the drawCardPileView to have a shuffled
	//	deck
	//---------------------------------------------------------------------------

	[ [ [ drawCardPile freeCards ] addDeck ] shuffle ] ;
	
	//---------------------------------------------------------------------------
	//	Initialize the discardCardPileView as empty
	//---------------------------------------------------------------------------

	[ [ discardCardPileView cardPile ] freeCards ] ;
	[ discardCardPileView display ] ;

	//---------------------------------------------------------------------------
	//	Initialize the four "suit piles" as empty
	//---------------------------------------------------------------------------

	for ( pileIndex = 0 ; pileIndex < 4 ; pileIndex++ )
	{
		[ [ suitCardPiles [ pileIndex ] cardPile ] freeCards ] ;
		[ suitCardPiles [ pileIndex ] display ] ;
	}

	//---------------------------------------------------------------------------
	//	Initialize and deal cards to the seven "user piles"
	//---------------------------------------------------------------------------

	for ( pileIndex = 0 ; pileIndex < 7 ; pileIndex++ )
	{
		id		userPile = [ gameCardPiles [ pileIndex ] cardPile ] ;
		
		[ userPile freeCards ] ;
		for ( cardIndex = 0 ; cardIndex <= pileIndex ; cardIndex++ )
		{
			id		tempCard = [ drawCardPile cardAt: CS_TOP ] ;
			
			[ drawCardPile removeCard: tempCard ] ;
			[ userPile insertCard: tempCard at: CS_TOP ] ;
		}
		[ [ userPile cardAt: CS_TOP ] flip ] ;
		[ gameCardPiles [ pileIndex ] display ] ;
	}

	//---------------------------------------------------------------------------
	//	Draw the remaining cards on the
	//	drawCardPileView
	//---------------------------------------------------------------------------

	[ drawCardPileView display ] ;
	
	[ gameWindow reenableFlushWindow ] ;
	[ gameWindow flushWindow ] ;
	[ gameWindow makeKeyAndOrderFront: self ] ;
	return self ;
}


- checkForWin
{
	if ( [ [ suitCardPileView1 cardPile ] cardCount ] +
			[ [ suitCardPileView2 cardPile ] cardCount ] +
			[ [ suitCardPileView3 cardPile ] cardCount ] +
			[ [ suitCardPileView4 cardPile ] cardCount ] == 52 )
	{
		[ [ Sound findSoundFor: "Trumpet.snd" ] play ] ;
		[ winPanel makeKeyAndOrderFront: self ] ;
	}
	return self ;
			
}
@end
